/*
* Copyright 2021 E.J.I.E., S.A.
*
* Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la «Licencia»);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en
*
* http://ec.europa.eu/idabc/eupl.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
* el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
* SIN GARANT�?AS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
* que establece la Licencia.
*/
package com.ejie.ad74a.service;

import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.odftoolkit.odfdom.doc.OdfSpreadsheetDocument;
import org.odftoolkit.odfdom.doc.table.OdfTable;
import org.odftoolkit.odfdom.doc.table.OdfTableRow;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ad74a.dao.AyuntamientosDao;
import com.ejie.ad74a.model.Ayuntamientos;
import com.ejie.ad74a.model.UnidadesBase;
import com.ejie.ad74a.model.UsuariosAyuntamiento;
import com.ejie.ad74a.util.comun.UtilLiterales;
import com.ejie.ad74a.util.comun.UtilSeguridad;
import com.ejie.ad74a.util.comun.UtilidadesFecha;
import com.ejie.ad74a.util.constantes.Constantes;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;
import com.lowagie.text.Document;
import com.lowagie.text.Phrase;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;

/**
 * AyuntamientosServiceImpl generated by UDA, 22-may-2023 16:38:14.
 * 
 * @author UDA
 */

@Service(value = "ayuntamientosService")
public class AyuntamientosServiceImpl implements AyuntamientosService {

	@Autowired
	private AyuntamientosDao ayuntamientosDao;

	@Autowired
	private UnidadesBaseService unidadesBaseService;

	@Resource
	private ReloadableResourceBundleMessageSource appMessageSource;

	@Autowired
	private Properties appConfiguration;

	/**
	 * Inserts a single row in the Ayuntamientos table.
	 *
	 * @param ayuntamientos Ayuntamientos
	 *
	 * @return Ayuntamientos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Ayuntamientos add(Ayuntamientos ayuntamientos, HttpServletRequest request) {
		if (ayuntamientos != null) {
			ayuntamientos.setUsuAlta31(UtilSeguridad.getUsuarioConectado().getUserName());
			ayuntamientos.setUsuModif31(UtilSeguridad.getUsuarioConectado().getUserName());
			ayuntamientos.setfAlta31(UtilidadesFecha.getFechaSistema());
			ayuntamientos.setfModif31(UtilidadesFecha.getFechaSistema());
		}

		// 1.- INSERTAR EL AYUNTAMIENTO
		Ayuntamientos ayunta = this.ayuntamientosDao.add(ayuntamientos);
		// 2.- SI TIENE UNIDADES BASE EN LA SESIÓN INSERTARLAS
		HttpSession sesion = request.getSession();
		List<UnidadesBase> unidadesBaseList = new ArrayList<UnidadesBase>();
		if (sesion.getAttribute(Constantes.VARCONTEXTO_UNIDADESBASE) != null) {
			unidadesBaseList = (List<UnidadesBase>) sesion.getAttribute(Constantes.VARCONTEXTO_UNIDADESBASE);
			for (UnidadesBase ub : unidadesBaseList) {
				ub.setIdProvincia92(ayunta.getProvincia().getCodProvincia());
				ub.setIdMunicipio92(ayunta.getMunicipio().getCodMunicipio());
				ub.setBaja92("0");
				ub.setUsuAlta92(UtilSeguridad.getUsuarioConectado().getUserName());
				ub.setFecAlta92(UtilidadesFecha.getFechaSistema());
				this.unidadesBaseService.add(ub);
			}
		}
		return ayunta;
	}

	/**
	 * Updates a single row in the Ayuntamientos table.
	 *
	 * @param ayuntamientos Ayuntamientos
	 *
	 * @return Ayuntamientos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Ayuntamientos update(Ayuntamientos ayuntamientos) {
		if (ayuntamientos != null) {
			ayuntamientos.setUsuModif31(UtilSeguridad.getUsuarioConectado().getUserName());
			ayuntamientos.setfModif31(UtilidadesFecha.getFechaSistema());
		}

		return this.ayuntamientosDao.update(ayuntamientos);
	}

	/**
	 * Finds a single row in the Ayuntamientos table.
	 *
	 * @param ayuntamientos Ayuntamientos
	 *
	 * @return Ayuntamientos
	 */
	public Ayuntamientos find(Ayuntamientos ayuntamientos) {
		return (Ayuntamientos) this.ayuntamientosDao.find(ayuntamientos);
	}

	/**
	 * Deletes a single row in the Ayuntamientos table.
	 *
	 * @param ayuntamientos Ayuntamientos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(Ayuntamientos ayuntamientos) {
		this.ayuntamientosDao.remove(ayuntamientos);
	}

	/**
	 * Updates a single row in the Ayuntamientos table.
	 *
	 * @param ayuntamientos Ayuntamientos
	 *
	 * @return Ayuntamientos
	 */
	@Transactional(rollbackFor = Throwable.class)
	public Ayuntamientos darBaja(Ayuntamientos ayuntamientos) {
		ayuntamientos.setUsuModif31(UtilSeguridad.getUsuarioConectado().getUserName());
		ayuntamientos.setfModif31(UtilidadesFecha.getFechaSistema());
		ayuntamientos.setfBaja31(UtilidadesFecha.getFechaSistema());
		return this.ayuntamientosDao.darBaja(ayuntamientos);
	}

	/**
	 * Finds a list of rows in the Ayuntamientos table.
	 *
	 * @param ayuntamientos   Ayuntamientos
	 * @param tableRequestDto TableRequestDto
	 *
	 * @return List<Ayuntamientos>
	 */
	public List<Ayuntamientos> findAll(Ayuntamientos ayuntamientos, TableRequestDto tableRequestDto) {
		return (List<Ayuntamientos>) this.ayuntamientosDao.findAll(ayuntamientos, tableRequestDto);
	}

	/**
	 * Finds rows in the Ayuntamientos table using like.
	 *
	 * @param ayuntamientos   Ayuntamientos
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith      Boolean
	 * 
	 * @return List<Ayuntamientos>
	 */
	public List<Ayuntamientos> findAllLike(Ayuntamientos ayuntamientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return (List<Ayuntamientos>) this.ayuntamientosDao.findAllLike(ayuntamientos, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Ayuntamientos table.
	 *
	 * @param tableRequestDto TableRequestDto
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void removeMultiple(TableRequestDto tableRequestDto) {
		this.ayuntamientosDao.removeMultiple(tableRequestDto);
	}

	/**
	 * Filter method in the Ayuntamientos table.
	 *
	 * @param filterAyuntamientos Ayuntamientos
	 * @param tableRequestDto     TableRequestDto
	 * @param startsWith          Boolean
	 *
	 * @return TableResponseDto<Ayuntamientos>
	 */
	public TableResponseDto<Ayuntamientos> filter(Ayuntamientos filterAyuntamientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		List<Ayuntamientos> listaAyuntamientos = this.ayuntamientosDao.findAllLike(filterAyuntamientos, tableRequestDto,
				false);
		Long recordNum = this.ayuntamientosDao
				.findAllLikeCount(filterAyuntamientos != null ? filterAyuntamientos : new Ayuntamientos(), false);
		TableResponseDto<Ayuntamientos> tableResponseDto = new TableResponseDto<Ayuntamientos>(tableRequestDto,
				recordNum, listaAyuntamientos);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null
				&& !tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			List<TableRowDto<Ayuntamientos>> reorderSelection = this.ayuntamientosDao
					.reorderSelection(filterAyuntamientos, tableRequestDto, startsWith);
			tableResponseDto.setReorderedSelection(reorderSelection);
			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<Ayuntamientos>> reorderSeeker = this.ayuntamientosDao.reorderSelection(filterAyuntamientos,
					tableRequestDto, startsWith);
			tableResponseDto.setReorderedSeeker(reorderSeeker);
			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return tableResponseDto;
	}

	public Long numAyuntamientoEnProvinciaYMunicipio(Ayuntamientos ayuntamiento) {

		return this.ayuntamientosDao.findAllLikeCountValidarExiteAyuntamiento(ayuntamiento, false);
	};

	/**
	 * Searches rows in the Ayuntamientos table.
	 *
	 * @param filterAyuntamientos Ayuntamientos
	 * @param searchAyuntamientos Ayuntamientos
	 * @param tableRequestDto     TableRequestDto
	 * @param startsWith          Boolean
	 *
	 * @return List<TableRowDto<Ayuntamientos>>
	 */
	public List<TableRowDto<Ayuntamientos>> search(Ayuntamientos filterAyuntamientos, Ayuntamientos searchAyuntamientos,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.ayuntamientosDao.search(filterAyuntamientos, searchAyuntamientos, tableRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in Ayuntamientos table.
	 *
	 * @param filterAyuntamientos Ayuntamientos
	 * @param tableRequestDto     TableRequestDto
	 * @param startsWith          Boolean
	 *
	 * @return Object
	 */
	public Object reorderSelection(Ayuntamientos filterAyuntamientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.ayuntamientosDao.reorderSelection(filterAyuntamientos, tableRequestDto, startsWith);
	}

	@Transactional(rollbackFor = Throwable.class)
	public List<Ayuntamientos> getMultiple(Ayuntamientos filterAyuntamientos, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.ayuntamientosDao.getMultiple(filterAyuntamientos, tableRequestDto, startsWith);
	}

	/**
	 * Devuelve un fichero en el formato deseado que contiene los datos exportados
	 * de la tabla.
	 *
	 * @param filterAyuntamientos Ayuntamientos
	 * @param columns             String[]
	 * @param columnsName         String[]
	 * @param fileName            String
	 * @param sheetTitle          String
	 * @param reportsParams       ArrayList<?>
	 * @param tableRequestDto     TableRequestDto
	 * @param request             HttpServletRequest
	 * @param response            HttpServletResponse
	 */
	@Override
	public void generateReport(Ayuntamientos filterAyuntamientos, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, ArrayList<?> reportsParams, TableRequestDto tableRequestDto,
			HttpServletRequest request, HttpServletResponse response) {
		// Accede a la DB para recuperar datos
		List<Ayuntamientos> filteredData = getDataForReports(filterAyuntamientos, tableRequestDto);
		String extension = null;

		// Comprobar si las siguientes variables estan vacias, en caso de estarlo se las
		// asigna un valor generico
		fileName = (fileName != null && !fileName.isEmpty()) ? fileName : "report";
		sheetTitle = (sheetTitle != null && !sheetTitle.isEmpty()) ? sheetTitle : Ayuntamientos.class.getSimpleName();

		// Obtener el formato de fecha especifico del locale
		SimpleDateFormat formatter = DateTimeManager.getDateTimeFormat(request.getLocale());

		// Cuando no se definen columnas porque se quieren obtener todas
		if (columns == null) {
			Field[] fields = Ayuntamientos.class.getDeclaredFields();
			ArrayList<String> tempColumns = new ArrayList<String>();

			for (int i = 0; i < fields.length; i++) {
				try {
					String methodName = fields[i].getName();
					methodName = methodName.substring(0, 1).toUpperCase() + methodName.substring(1);
					Ayuntamientos.class.getMethod("get" + methodName);
					tempColumns.add(fields[i].getName());
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}

			}
			columns = tempColumns.toArray(new String[0]);
		}

		// Si no se definen los nombres de las columnas se dejan las definidas por
		// defecto
		if (columnsName == null) {
			columnsName = columns;
		}

		String servletPath = request.getServletPath();
		String reportType = null;
		if (servletPath.contains("/") && (servletPath.lastIndexOf("/") + 1 != servletPath.length())) {
			reportType = servletPath.substring(servletPath.lastIndexOf("/") + 1, servletPath.length());
		} else {
			reportType = servletPath.substring(0, servletPath.length());
		}

		if (reportType.equals("xlsReport")) {
			extension = ".xls";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("xlsxReport")) {
			extension = ".xlsx";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("pdfReport")) {
			extension = ".pdf";
			generatePDFReport(filteredData, columns, columnsName, fileName, response);
		} else if (reportType.equals("odsReport")) {
			extension = ".ods";
			generateODSReport(filteredData, columns, columnsName, fileName, sheetTitle, response);
		} else if (reportType.equals("csvReport")) {
			extension = ".csv";
			// Obtener idioma
			String language = request.getLocale().getLanguage();
			generateCSVReport(filteredData, columns, columnsName, fileName, sheetTitle, language, response);
		}

	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Ayuntamientos>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param extension    String
	 * @param formatter    SimpleDateFormat
	 * @param response     HttpServletResponse
	 */
	private void generateExcelReport(List<Ayuntamientos> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String extension, SimpleDateFormat formatter,
			HttpServletResponse response) {
		try {
			// Creacion del Excel
			Workbook workbook = null;
			if (extension == ".xlsx") {
				workbook = new XSSFWorkbook();
				response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			} else {
				workbook = new HSSFWorkbook();
				response.setContentType("application/vnd.ms-excel");
			}

			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + extension + "");

			// Creacion de una hoja y asignacion de su nombre
			Sheet sheet = workbook.createSheet(sheetTitle);

			// Se crea una fuente para estilizar las cabeceras
			Font headerFont = workbook.createFont();
			headerFont.setBold(true);
			headerFont.setFontHeightInPoints((short) 12);

			// Se crea un CellStyle con la fuente
			CellStyle headerCellStyle = workbook.createCellStyle();
			headerCellStyle.setAlignment(HorizontalAlignment.CENTER);
			headerCellStyle.setFont(headerFont);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Se crea la fila para insertar los titulos de las columnas
			Row row = sheet.createRow(rowNumber++);

			// Añadir titulos
			for (int i = 0; i < columnsName.length; i++) {
				Cell cell = row.createCell(i);
				cell.setCellValue(
						UtilLiterales.getLiteralMessage(appMessageSource, "excelReportLiteral." + columnsName[i]));
				cell.setCellStyle(headerCellStyle);
			}

			// CreationHelper ayudara a mantener la compatibilidad del DataFormat tanto si
			// se crea un .xls como un .xlsx
			CreationHelper createHelper = workbook.getCreationHelper();

			// Se crea un CellStyle para añadir el formateador de fechas
			CellStyle dateCellStyle = workbook.createCellStyle();
			dateCellStyle.setDataFormat(createHelper.createDataFormat().getFormat(formatter.toPattern()));

			// Añadir datos
			for (Ayuntamientos rowAyuntamientos : filteredData) {
				int cellNumber = 0;
				row = sheet.createRow(rowNumber++);

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					Cell cellAyuntamientos = row.createCell(cellNumber++);
					cellAyuntamientos.setCellValue(getCellValue(column, rowAyuntamientos));
				}
			}

			// Se adapta el ancho de las columnas al contenido
			for (int i = 0; i < columns.length; i++) {
				sheet.autoSizeColumn(i);
			}

			// Se añade el fichero excel al response
			workbook.write(response.getOutputStream());
			workbook.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Ayuntamientos>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param response     HttpServletResponse
	 */
	private void generatePDFReport(List<Ayuntamientos> filteredData, String[] columns, String[] columnsName,
			String fileName, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".pdf");
			response.setContentType("application/pdf");

			Document document = new Document();
			// Se añade el fichero pdf al response
			PdfWriter.getInstance(document, response.getOutputStream());

			document.open();

			PdfPTable table = new PdfPTable(columns.length);

			for (String column : columnsName) {
				PdfPCell header = new PdfPCell();
				header.setBorderWidth(2);
				header.setPhrase(new Phrase(column));
				table.addCell(header);
			}

			// Añadir datos
			for (Ayuntamientos rowAyuntamientos : filteredData) {
				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					table.addCell(getCellValue(column, rowAyuntamientos));
				}
			}

			document.add(table);
			document.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Ayuntamientos>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param response     HttpServletResponse
	 */
	private void generateODSReport(List<Ayuntamientos> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, HttpServletResponse response) {
		try {
			// Se añade el fichero ods al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".ods");
			response.setContentType("application/vnd.oasis.opendocument.spreadsheet");

			OdfSpreadsheetDocument ods = OdfSpreadsheetDocument.newSpreadsheetDocument();
			ods.getOrCreateDocumentStyles();

			// Hay que eliminar la hoja que se genera por defecto
			ods.getTableByName("Sheet1").remove();

			// Hoja nueva
			OdfTable table = OdfTable.newTable(ods, filteredData.size() + 1, columns.length);
			table.setTableName(sheetTitle);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Cabeceras
			OdfTableRow row = table.getRowByIndex(rowNumber++);
			for (int i = 0; i < columnsName.length; i++) {
				row.getCellByIndex(i).setStringValue(columnsName[i]);
			}

			// Añadir datos
			for (Ayuntamientos rowAyuntamientos : filteredData) {
				row = table.getRowByIndex(rowNumber++);
				int cellNumber = 0;

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					row.getCellByIndex(cellNumber++).setStringValue(getCellValue(column, rowAyuntamientos));
				}
			}

			// Se añade el fichero ods al response
			ods.save(response.getOutputStream());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<Ayuntamientos>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param language     String
	 * @param response     HttpServletResponse
	 */
	private void generateCSVReport(List<Ayuntamientos> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String language, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".csv");
			response.setContentType("text/csv");

			// Separador de campos dependiendo del idioma
			String separator = ";";
			if (language.equals("en")) {
				separator = ",";
			}

			// Se añade el fichero csv al response
			OutputStream out = response.getOutputStream();
			// Añadir titulos
			boolean addTitles = true;

			// Añadir datos
			for (Ayuntamientos rowAyuntamientos : filteredData) {
				int cellNumber = 1;
				StringBuilder columnsTitles = new StringBuilder();
				StringBuilder row = new StringBuilder();

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					String cellValue = getCellValue(column, rowAyuntamientos);

					if (cellNumber < columns.length) {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"");
							columnsTitles.append(separator);
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"");
						row.append(separator);
						cellNumber++;
					} else {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"\n");
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"\n");
					}
				}

				if (addTitles) {
					out.write(columnsTitles.toString().getBytes());
					addTitles = false;
				}
				out.write(row.toString().getBytes());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve los datos recuperados de la DB.
	 *
	 * @param filterAyuntamientos Ayuntamientos
	 * @param tableRequestDto     TableRequestDto
	 *
	 * @return List<Ayuntamientos>
	 */
	public List<Ayuntamientos> getDataForReports(Ayuntamientos filterAyuntamientos, TableRequestDto tableRequestDto) {
		if (tableRequestDto.getMultiselection().getSelectedAll()
				&& tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			if (filterAyuntamientos != null) {
				return this.ayuntamientosDao.findAllLike(filterAyuntamientos, tableRequestDto, false);
			} else {
				return this.ayuntamientosDao.findAllLike(filterAyuntamientos, tableRequestDto, false);
			}
		} else {
			return this.ayuntamientosDao.findAllLike(filterAyuntamientos, tableRequestDto, false);
		}
	}

	/**
	 * Busca los ayuntamientos buscando por el usuario XlNets
	 * 
	 * @param usuariosAyuntamiento {@link UsuariosAyuntamiento}
	 * @return {@link List} of {@link Ayuntamientos}
	 */
	@Override
	public List<Ayuntamientos> findComboByUsuarioConectado(UsuariosAyuntamiento usuariosAyuntamiento) {
		return this.ayuntamientosDao.findComboByUsuarioConectado(usuariosAyuntamiento);
	}

	/**
	 * Obtiene los valores de las celdas.
	 *
	 * @param column           String
	 * @param rowAyuntamientos Ayuntamientos
	 *
	 * @return String
	 */
	private String getCellValue(String column, Ayuntamientos rowAyuntamientos) {
		String cellValue = "";
		try {
			cellValue = BeanUtils.getProperty(rowAyuntamientos, column) != null
					? BeanUtils.getProperty(rowAyuntamientos, column)
					: "";
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		}

		return cellValue;
	}

//	public Map<String, String> lanzarPeticion_A_O75(BigDecimal idLote, HttpServletRequest request) {
//        StringBuilder res = new StringBuilder(3000);
//        Map<String, String> resultado = new HashMap<String, String>();
//
//        String ejecutable = "EnvMailSMS.sh";
//
//        String buzon = (String) this.appConfiguration.getProperty("o75.buzon");
//        String propietario = (String) this.appConfiguration.getProperty("o75.propietario");
//
//        String descripcion = "envioMailSMS";
//        String aplic = "ab37a";
//        String runtime = O75API.RUNTIME_SH;
//
//        SimpleDateFormat sdfDate = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
//        Date now = new Date();
//        String fecPeticion = sdfDate.format(now);
//
//        String usuSISSA = Constantes.APLICACION;
//        try {
//            usuSISSA = UtilSeguridad.getInstance().getUserCredentials().getPosition();
//        } catch (Exception e) {
//            EnvioMailSMSDaoImpl.logger
//                    .info("El UserCredentials es nulo. Usamos AB37A como usuario para la petición O75");
//        }
//
//        // conjunto de parametros que se le va a pasar al proceso cobol
//        String par1 = "@@" + idLote + "@@";
//
//        try {
//            O75Peticion o75pet = new O75Peticion();
//
//            o75pet.SetBuzon(buzon);
//            o75pet.SetAplicacion(aplic);
//            o75pet.SetUsuario(usuSISSA);
//            o75pet.SetRuntime(runtime);
//            o75pet.SetFechaPeticion(fecPeticion);
//            o75pet.SetIdShell(ejecutable);
//            o75pet.SetParam1(par1);
//            o75pet.SetDescripcion(descripcion);
//            o75pet.SetTipoPeticion(O75API.TIPOPET_ROLTIPO);
//            o75pet.SetTipo(O75API.TIPO_DIRECTO);
//            o75pet.SetSubtipo(O75API.SUBTIPO_RELANZABLE);
//            o75pet.SetPrioridad(O75API.PRIORIDAD_ALTA);
//            o75pet.SetPropietario(propietario);
//
//            // Descomentar al subir a otro entorno que no sea local
//            // O75API o75api = new O75API(request);
//
//            // Descomentar al probar en local
//            O75API o75api = new O75API(UtilSeguridad.getInstance().getTokenDocumentXLNets(Constantes.APLICACION));
//
//            Integer nRet = o75api.Alta(o75pet);
//            EnvioMailSMSDaoImpl.logger.info("Parametros enviados a O75: " + o75pet.GetBuzon()
//                    + Constantes.SEPARADOR_COMA_SIN_ESPACIO + o75pet.GetAplicacion()
//                    + Constantes.SEPARADOR_COMA_SIN_ESPACIO + o75pet.GetUsuario()
//                    + Constantes.SEPARADOR_COMA_SIN_ESPACIO + o75pet.GetRuntime()
//                    + Constantes.SEPARADOR_COMA_SIN_ESPACIO + o75pet.GetFechaPeticion()
//                    + Constantes.SEPARADOR_COMA_SIN_ESPACIO + o75pet.GetIdShell()
//                    + Constantes.SEPARADOR_COMA_SIN_ESPACIO + o75pet.GetParam1() + Constantes.SEPARADOR_COMA_SIN_ESPACIO
//                    + o75pet.GetFechaPeticion() + Constantes.SEPARADOR_COMA_SIN_ESPACIO + o75pet.GetDescripcion()
//                    + Constantes.SEPARADOR_COMA_SIN_ESPACIO + o75pet.GetTipoPet()
//                    + Constantes.SEPARADOR_COMA_SIN_ESPACIO + o75pet.GetTipo() + Constantes.SEPARADOR_COMA_SIN_ESPACIO
//                    + o75pet.GetSubtipo() + Constantes.SEPARADOR_COMA_SIN_ESPACIO + o75pet.GetPrioridad());
//
//            resultado.put("nRet", nRet.toString());
//            resultado.put("numPeticion", Long.toString(o75pet.GetNumeroPeticion()));
//
//            if (0 == nRet) {
//                res.append("Lote cod idLote=").append(idLote).append("<br/>");
//                res.append("Batch de Destinatarois <br />");
//                res.append("Petición nº: " + o75pet.GetNumeroPeticion() + "<br />");
//                res.append("Se va a relanzar el lote para los destinatarios con error<br />");
//
//            } else {
//                res.append("Error en la petición de relanzar un lote erroneo = ").append(idLote);
//                res.append("Petición nº: " + o75pet.GetNumeroPeticion());
//                res.append("Código: " + o75api.GetCodigoError());
//                res.append("Descripción: " + o75api.GetDec());
//                resultado.put("codError", Integer.toString(o75api.GetCodigoError()));
//                resultado.put("desc", o75api.GetDec());
//                EnvioMailSMSDaoImpl.logger.info(res.toString());
//
//            }
//        } catch (Exception e) {
//            res.append("Contabilizaci&oacute;n Batch de Documentos <br />");
//            res.append("Se ha producido un error al incorporar el fichero para el lote con codPeticion= ")
//                    .append(idLote);
//            EnvioMailSMSDaoImpl.logger.error(res.toString(), e);
//			}
//
//// System.out.println("#########" + res.toString());
//
//return resultado;

//}
}
